commit 60827da1e8795827d0be2c2d7bcd7871e50fdb9c
Author: freddy77 <freddy77>
Date:   Thu Nov 26 09:47:40 2009 +0000

    Move server_addr into ctlib

diff --git a/ChangeLog b/ChangeLog
index 725255a..2ddd0d8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Nov 26 10:46:01 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/ctlib.h include/tds.h src/ctlib/ct.c src/tds/config.c:
+	* src/tds/login.c src/tds/mem.c:
+	- Move server_addr into ctlib
+
 Thu Nov 26 10:06:51 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* include/tds.h src/tds/data.c src/tds/tds_checks.c:
 	* src/tds/tds_checks.h src/tds/token.c:
@@ -1912,4 +1917,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2888 2009/11/26 09:07:27 freddy77 Exp $
+$Id: ChangeLog,v 1.2889 2009/11/26 09:47:40 freddy77 Exp $
diff --git a/include/ctlib.h b/include/ctlib.h
index a047851..98e213d 100644
--- a/include/ctlib.h
+++ b/include/ctlib.h
@@ -36,7 +36,7 @@ extern "C"
 #endif
 #endif
 
-static const char rcsid_ctlib_h[] = "$Id: ctlib.h,v 1.27 2009/06/08 19:55:11 freddy77 Exp $";
+static const char rcsid_ctlib_h[] = "$Id: ctlib.h,v 1.28 2009/11/26 09:47:41 freddy77 Exp $";
 static const void *const no_unused_ctlib_h_warn[] = { rcsid_ctlib_h, no_unused_ctlib_h_warn };
 
 #include <tds.h>
@@ -127,6 +127,7 @@ struct _cs_connection
 	CS_LOCALE *locale;
 	CS_COMMAND_LIST *cmds;
 	CS_DYNAMIC_LIST *dynlist;
+	char *server_addr;
 };
 
 /*
diff --git a/include/tds.h b/include/tds.h
index 61c2280..ad67cc3 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.322 2009/11/26 09:07:28 freddy77 Exp $ */
+/* $Id: tds.h,v 1.323 2009/11/26 09:47:41 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -838,7 +838,6 @@ typedef union
 typedef struct tds_login
 {
 	DSTR server_name;
-	DSTR server_addr;
 	int port;
 	TDS_USMALLINT tds_version;	/* TDS version */
 	int block_size;
@@ -1474,7 +1473,6 @@ void tds_set_bulk(TDSLOGIN * tds_login, TDS_TINYINT enabled);
 void tds_set_user(TDSLOGIN * tds_login, const char *username);
 void tds_set_app(TDSLOGIN * tds_login, const char *application);
 void tds_set_host(TDSLOGIN * tds_login, const char *hostname);
-void tds_set_server_addr(TDSLOGIN * tds_login, const char *server_addr);
 void tds_set_library(TDSLOGIN * tds_login, const char *library);
 void tds_set_server(TDSLOGIN * tds_login, const char *server);
 void tds_set_client_charset(TDSLOGIN * tds_login, const char *charset);
diff --git a/src/ctlib/ct.c b/src/ctlib/ct.c
index aa7b79e..71b511f 100644
--- a/src/ctlib/ct.c
+++ b/src/ctlib/ct.c
@@ -39,7 +39,7 @@
 #include "tdsstring.h"
 #include "replacements.h"
 
-TDS_RCSID(var, "$Id: ct.c,v 1.200 2009/11/23 08:50:28 freddy77 Exp $");
+TDS_RCSID(var, "$Id: ct.c,v 1.201 2009/11/26 09:47:41 freddy77 Exp $");
 
 
 static char * ct_describe_cmd_state(CS_INT state);
@@ -286,6 +286,7 @@ ct_con_alloc(CS_CONTEXT * ctx, CS_CONNECTION ** con)
 		return CS_FAIL;
 	}
 	(*con)->tds_login = login;
+	(*con)->server_addr = NULL;
 
 	/* so we know who we belong to */
 	(*con)->ctx = ctx;
@@ -347,7 +348,6 @@ ct_con_props(CS_CONNECTION * con, CS_INT action, CS_INT property, CS_VOID * buff
 	CS_INT intval = 0, maxcp;
 	TDSSOCKET *tds;
 	TDSLOGIN *tds_login;
-	char *set_buffer = NULL;
 
 	tdsdump_log(TDS_DBG_FUNC, "ct_con_props(%p, %d, %d, %p, %d, %p)\n", con, action, property, buffer, buflen, out_len);
 
@@ -357,6 +357,8 @@ ct_con_props(CS_CONNECTION * con, CS_INT action, CS_INT property, CS_VOID * buff
 	tds_login = con->tds_login;
 
 	if (action == CS_SET) {
+		char *set_buffer = NULL;
+
 		if (property == CS_USERNAME || property == CS_PASSWORD || property == CS_APPNAME ||
 			property == CS_HOSTNAME || property == CS_SERVERADDR) {
 			if (buflen == CS_NULLTERM) {
@@ -402,8 +404,10 @@ ct_con_props(CS_CONNECTION * con, CS_INT action, CS_INT property, CS_VOID * buff
 			if (!host || !port)
 				return CS_FAIL;
 
-			portno= (int)strtol(port, NULL, 10);
-			tds_set_server_addr(tds_login, host);
+			portno = (int)strtol(port, NULL, 10);
+			if (portno < 1 || portno >= 65536)
+				return CS_FAIL;
+			con->server_addr = strdup(host);
 			tds_set_port(tds_login, portno);
 			break;
 		}
@@ -587,8 +591,8 @@ ct_connect(CS_CONNECTION * con, CS_CHAR * servername, CS_INT snamelen)
 
 	tdsdump_log(TDS_DBG_FUNC, "ct_connect(%p, %s, %d)\n", con, servername ? servername : "NULL", snamelen);
 
-	if (!tds_dstr_isempty(&con->tds_login->server_addr)) {
-		server = tds_dstr_buf(&con->tds_login->server_addr);
+	if (con->server_addr) {
+		server = "";
 	} else if (snamelen == 0 || snamelen == CS_UNUSED) {
 		server = NULL;
 	} else if (snamelen == CS_NULLTERM) {
@@ -611,6 +615,8 @@ ct_connect(CS_CONNECTION * con, CS_CHAR * servername, CS_INT snamelen)
 		con->tds_socket = NULL;
 		return CS_FAIL;
 	}
+	if (con->server_addr)
+		tds_dstr_copy(&connection->server_host_name, con->server_addr);
 
 	/* override locale settings with CS_CONNECTION settings, if any */
 	if (con->locale) {
@@ -1896,6 +1902,7 @@ ct_con_drop(CS_CONNECTION * con)
 		}
 		if (con->locale)
 			_cs_locale_free(con->locale);
+		free(con->server_addr);
 		free(con);
 	}
 	return CS_SUCCEED;
diff --git a/src/tds/config.c b/src/tds/config.c
index 0e98808..6610c5f 100644
--- a/src/tds/config.c
+++ b/src/tds/config.c
@@ -76,7 +76,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: config.c,v 1.150 2009/11/24 15:48:52 freddy77 Exp $");
+TDS_RCSID(var, "$Id: config.c,v 1.151 2009/11/26 09:47:41 freddy77 Exp $");
 
 static void tds_config_login(TDSCONNECTION * connection, TDSLOGIN * login);
 static void tds_config_env_tdsdump(TDSCONNECTION * connection);
@@ -367,6 +367,8 @@ static int
 tds_read_conf_sections(FILE * in, const char *server, TDSCONNECTION * connection)
 {
 	tds_read_conf_section(in, "global", tds_parse_conf_section, connection);
+	if (!server[0])
+		return 0;
 	rewind(in);
 	return tds_read_conf_section(in, server, tds_parse_conf_section, connection);
 }
diff --git a/src/tds/login.c b/src/tds/login.c
index 05be59a..223d3d9 100644
--- a/src/tds/login.c
+++ b/src/tds/login.c
@@ -51,7 +51,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: login.c,v 1.189 2009/09/28 14:07:04 freddy77 Exp $");
+TDS_RCSID(var, "$Id: login.c,v 1.190 2009/11/26 09:47:41 freddy77 Exp $");
 
 static int tds_send_login(TDSSOCKET * tds, TDSCONNECTION * connection);
 static int tds8_do_login(TDSSOCKET * tds, TDSCONNECTION * connection);
@@ -145,14 +145,6 @@ tds_set_server(TDSLOGIN * tds_login, const char *server)
 }
 
 void
-tds_set_server_addr(TDSLOGIN * tds_login, const char *server_addr)
-{
-	if (server_addr) {
-		tds_dstr_copy(&tds_login->server_addr, server_addr);
-	}
-}
-
-void
 tds_set_library(TDSLOGIN * tds_login, const char *library)
 {
 	tds_dstr_copy(&tds_login->library, library);
diff --git a/src/tds/mem.c b/src/tds/mem.c
index 81f0eb5..43987a4 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -41,7 +41,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.192 2009/11/22 21:49:49 jklowden Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.193 2009/11/26 09:47:41 freddy77 Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -982,7 +982,6 @@ tds_alloc_login(void)
 	
 	TEST_MALLOC(tds_login, TDSLOGIN);
 	tds_dstr_init(&tds_login->server_name);
-	tds_dstr_init(&tds_login->server_addr);
 	tds_dstr_init(&tds_login->language);
 	tds_dstr_init(&tds_login->server_charset);
 	tds_dstr_init(&tds_login->client_host_name);
@@ -1017,7 +1016,6 @@ tds_free_login(TDSLOGIN * login)
 		tds_dstr_zero(&login->password);
 		tds_dstr_free(&login->password);
 		tds_dstr_free(&login->server_name);
-		tds_dstr_free(&login->server_addr);
 		tds_dstr_free(&login->language);
 		tds_dstr_free(&login->server_charset);
 		tds_dstr_free(&login->client_host_name);

